diff --git a/gcc/go/go-lang.c b/gcc/go/go-lang.c
index c0f2f1f..a92dd70 100644
--- a/gcc/go/go-lang.c
+++ b/gcc/go/go-lang.c
@@ -267,8 +267,8 @@ go_langhook_post_options (const char **pfilename ATTRIBUTE_UNUSED)
     go_add_search_path (dir);
   go_search_dirs.release ();
 
-  if (flag_excess_precision_cmdline == EXCESS_PRECISION_DEFAULT)
-    flag_excess_precision_cmdline = EXCESS_PRECISION_STANDARD;
+  if (GCC_OPTION (flag_excess_precision_cmdline) == EXCESS_PRECISION_DEFAULT)
+    GCC_OPTION (flag_excess_precision_cmdline) = EXCESS_PRECISION_STANDARD;
 
   /* Tail call optimizations can confuse uses of runtime.Callers.  */
   if (!global_options_set.x_flag_optimize_sibling_calls)
@@ -281,8 +281,8 @@ go_langhook_post_options (const char **pfilename ATTRIBUTE_UNUSED)
 static void
 go_langhook_parse_file (void)
 {
-  go_parse_input_files (in_fnames, num_in_fnames, flag_syntax_only,
-			go_require_return_statement);
+  go_parse_input_files (in_fnames, num_in_fnames, GCC_OPTION (flag_syntax_only),
+			GCC_OPTION (go_require_return_statement));
 }
 
 static tree
diff --git a/gcc/go/gofrontend/expressions.cc b/gcc/go/gofrontend/expressions.cc
index 6ac18f5..4106728 100644
--- a/gcc/go/gofrontend/expressions.cc
+++ b/gcc/go/gofrontend/expressions.cc
@@ -5583,7 +5583,7 @@ Binary_expression::do_flatten(Gogo*, Named_object*,
   // defined in gcc/go/lang.opt.  These should be defined in go_create_gogo
   // and accessed from the Gogo* passed to do_flatten.
   if (is_shift_op
-      || (is_idiv_op && (go_check_divide_zero || go_check_divide_overflow)))
+      || (is_idiv_op && (GCC_OPTION (go_check_divide_zero) || GCC_OPTION (go_check_divide_overflow))))
     {
       if (!this->left_->is_variable())
         {
@@ -6163,7 +6163,7 @@ Binary_expression::do_get_tree(Translate_context* context)
   // Add checks for division by zero and division overflow as needed.
   if (is_idiv_op)
     {
-      if (go_check_divide_zero)
+      if (GCC_OPTION (go_check_divide_zero))
 	{
 	  // right == 0
           Bexpression* zero_expr =
@@ -6182,7 +6182,7 @@ Binary_expression::do_get_tree(Translate_context* context)
                                                         crash_expr, ret, loc);
 	}
 
-      if (go_check_divide_overflow)
+      if (GCC_OPTION (go_check_divide_overflow))
 	{
 	  // right == -1
 	  // FIXME: It would be nice to say that this test is expected
@@ -9849,7 +9849,7 @@ Call_expression::do_get_tree(Translate_context* context)
 
   // This is to support builtin math functions when using 80387 math.
   tree excess_type = NULL_TREE;
-  if (optimize
+  if (GCC_OPTION (optimize)
       && TREE_CODE(fndecl) == FUNCTION_DECL
       && DECL_IS_BUILTIN(fndecl)
       && DECL_BUILT_IN_CLASS(fndecl) == BUILT_IN_NORMAL
diff --git a/gcc/graphite-clast-to-gimple.c b/gcc/graphite-clast-to-gimple.c
index fc60845..5ebbcd2 100644
--- a/gcc/graphite-clast-to-gimple.c
+++ b/gcc/graphite-clast-to-gimple.c
@@ -1196,7 +1196,7 @@ translate_clast_for_loop (loop_p context_loop, struct clast_for *stmt,
   isl_set *domain = isl_set_from_cloog_domain (stmt->domain);
   int scheduling_dim = isl_set_n_dim (domain);
 
-  if (flag_loop_parallelize_all
+  if (GCC_OPTION (flag_loop_parallelize_all)
       && loop_is_parallel_p (loop, bb_pbb_mapping, scheduling_dim))
     loop->can_be_parallel = true;
 
@@ -1399,11 +1399,11 @@ static FILE *
 init_cloog_input_file (int scop_number)
 {
   FILE *graphite_out_file;
-  int len = strlen (dump_base_name);
+  int len = strlen (GCC_OPTION (dump_base_name));
   char *dumpname = XNEWVEC (char, len + 25);
   char *s_scop_number = XNEWVEC (char, 15);
 
-  memcpy (dumpname, dump_base_name, len + 1);
+  memcpy (dumpname, GCC_OPTION (dump_base_name), len + 1);
   strip_off_ending (dumpname, len);
   sprintf (s_scop_number, ".%d", scop_number);
   strcat (dumpname, s_scop_number);
diff --git a/gcc/graphite-poly.c b/gcc/graphite-poly.c
index 4ca62f9..259d55a 100644
--- a/gcc/graphite-poly.c
+++ b/gcc/graphite-poly.c
@@ -236,26 +236,26 @@ apply_poly_transforms (scop_p scop)
      transformation: GIMPLE -> GRAPHITE -> GIMPLE
      Keep in mind that CLooG optimizes in control, so the loop structure
      may change, even if we only use -fgraphite-identity.  */
-  if (flag_graphite_identity)
+  if (GCC_OPTION (flag_graphite_identity))
     transform_done = true;
 
-  if (flag_loop_parallelize_all)
+  if (GCC_OPTION (flag_loop_parallelize_all))
     transform_done = true;
 
-  if (flag_loop_block)
+  if (GCC_OPTION (flag_loop_block))
     transform_done |= scop_do_block (scop);
   else
     {
-      if (flag_loop_strip_mine)
+      if (GCC_OPTION (flag_loop_strip_mine))
 	transform_done |= scop_do_strip_mine (scop, 0);
 
-      if (flag_loop_interchange)
+      if (GCC_OPTION (flag_loop_interchange))
 	transform_done |= scop_do_interchange (scop);
     }
 
   /* This pass needs to be run at the final stage, as it does not
      update the lst.  */
-  if (flag_loop_optimize_isl)
+  if (GCC_OPTION (flag_loop_optimize_isl))
     transform_done |= optimize_isl (scop);
 
   return transform_done;
diff --git a/gcc/graphite-sese-to-poly.c b/gcc/graphite-sese-to-poly.c
index d4a1bb2..77dd68c 100644
--- a/gcc/graphite-sese-to-poly.c
+++ b/gcc/graphite-sese-to-poly.c
@@ -1857,7 +1857,7 @@ dump_alias_graphs (vec<data_reference_p> drs)
   file_dimacs = fopen ("/tmp/dr_alias_graph_dimacs", "ab");
   if (file_dimacs)
     {
-      snprintf (comment, sizeof (comment), "%s %s", main_input_filename,
+      snprintf (comment, sizeof (comment), "%s %s", GCC_OPTION (main_input_filename),
 		current_function_name ());
       write_alias_graph_to_ascii_dimacs (file_dimacs, comment, drs);
       fclose (file_dimacs);
@@ -1866,7 +1866,7 @@ dump_alias_graphs (vec<data_reference_p> drs)
   file_ecc = fopen ("/tmp/dr_alias_graph_ecc", "ab");
   if (file_ecc)
     {
-      snprintf (comment, sizeof (comment), "%s %s", main_input_filename,
+      snprintf (comment, sizeof (comment), "%s %s", GCC_OPTION (main_input_filename),
 		current_function_name ());
       write_alias_graph_to_ascii_ecc (file_ecc, comment, drs);
       fclose (file_ecc);
@@ -1875,7 +1875,7 @@ dump_alias_graphs (vec<data_reference_p> drs)
   file_dot = fopen ("/tmp/dr_alias_graph_dot", "ab");
   if (file_dot)
     {
-      snprintf (comment, sizeof (comment), "%s %s", main_input_filename,
+      snprintf (comment, sizeof (comment), "%s %s", GCC_OPTION (main_input_filename),
 		current_function_name ());
       write_alias_graph_to_ascii_dot (file_dot, comment, drs);
       fclose (file_dot);
@@ -2607,7 +2607,7 @@ is_reduction_operation_p (gimple stmt)
   gcc_assert (is_gimple_assign (stmt));
   code = gimple_assign_rhs_code (stmt);
 
-  return flag_associative_math
+  return GCC_OPTION (flag_associative_math)
     && commutative_tree_code (code)
     && associative_tree_code (code);
 }
@@ -3145,7 +3145,7 @@ build_poly_scop (scop_p scop)
   if (!scop_ivs_can_be_represented (scop))
     return;
 
-  if (flag_associative_math)
+  if (GCC_OPTION (flag_associative_math))
     rewrite_commutative_reductions_out_of_ssa (scop);
 
   build_sese_loop_nests (region);
diff --git a/gcc/graphite.c b/gcc/graphite.c
index 311b7e3..f90b1bd 100644
--- a/gcc/graphite.c
+++ b/gcc/graphite.c
@@ -339,15 +339,15 @@ gate_graphite_transforms (void)
 {
   /* Enable -fgraphite pass if any one of the graphite optimization flags
      is turned on.  */
-  if (flag_loop_block
-      || flag_loop_interchange
-      || flag_loop_strip_mine
-      || flag_graphite_identity
-      || flag_loop_parallelize_all
-      || flag_loop_optimize_isl)
-    flag_graphite = 1;
-
-  return flag_graphite != 0;
+  if (GCC_OPTION (flag_loop_block)
+      || GCC_OPTION (flag_loop_interchange)
+      || GCC_OPTION (flag_loop_strip_mine)
+      || GCC_OPTION (flag_graphite_identity)
+      || GCC_OPTION (flag_loop_parallelize_all)
+      || GCC_OPTION (flag_loop_optimize_isl))
+    GCC_OPTION (flag_graphite) = 1;
+
+  return GCC_OPTION (flag_graphite) != 0;
 }
 
 namespace {
diff --git a/gcc/haifa-sched.c b/gcc/haifa-sched.c
index e0d4674..be9f6f3 100644
--- a/gcc/haifa-sched.c
+++ b/gcc/haifa-sched.c
@@ -2567,7 +2567,7 @@ rank_for_schedule (const void *x, const void *y)
     }
 
   /* The insn in a schedule group should be issued the first.  */
-  if (flag_sched_group_heuristic &&
+  if (GCC_OPTION (flag_sched_group_heuristic) &&
       SCHED_GROUP_P (tmp) != SCHED_GROUP_P (tmp2))
     return SCHED_GROUP_P (tmp2) ? 1 : -1;
 
@@ -2609,11 +2609,11 @@ rank_for_schedule (const void *x, const void *y)
   /* Prefer insn with higher priority.  */
   priority_val = INSN_PRIORITY (tmp2) - INSN_PRIORITY (tmp);
 
-  if (flag_sched_critical_path_heuristic && priority_val)
+  if (GCC_OPTION (flag_sched_critical_path_heuristic) && priority_val)
     return priority_val;
 
   /* Prefer speculative insn with greater dependencies weakness.  */
-  if (flag_sched_spec_insn_heuristic && spec_info)
+  if (GCC_OPTION (flag_sched_spec_insn_heuristic) && spec_info)
     {
       ds_t ds1, ds2;
       dw_t dw1, dw2;
@@ -2637,12 +2637,12 @@ rank_for_schedule (const void *x, const void *y)
     }
 
   info_val = (*current_sched_info->rank) (tmp, tmp2);
-  if (flag_sched_rank_heuristic && info_val)
+  if (GCC_OPTION (flag_sched_rank_heuristic) && info_val)
     return info_val;
 
   /* Compare insns based on their relation to the last scheduled
      non-debug insn.  */
-  if (flag_sched_last_insn_heuristic && last_nondebug_scheduled_insn)
+  if (GCC_OPTION (flag_sched_last_insn_heuristic) && last_nondebug_scheduled_insn)
     {
       dep_t dep1;
       dep_t dep2;
@@ -2694,7 +2694,7 @@ rank_for_schedule (const void *x, const void *y)
   val = (dep_list_size (tmp2, SD_LIST_FORW)
 	 - dep_list_size (tmp, SD_LIST_FORW));
 
-  if (flag_sched_dep_count_heuristic && val != 0)
+  if (GCC_OPTION (flag_sched_dep_count_heuristic) && val != 0)
     return val;
 
   /* If insns are equally good, sort by INSN_LUID (original insn order),
@@ -3863,7 +3863,7 @@ schedule_insn (rtx insn)
   if (INSN_TICK (insn) > clock_var)
     /* INSN has been prematurely moved from the queue to the ready list.
        This is possible only if following flag is set.  */
-    gcc_assert (flag_sched_stalled_insns);
+    gcc_assert (GCC_OPTION (flag_sched_stalled_insns));
 
   /* ??? Probably, if INSN is scheduled prematurely, we should leave
      INSN_TICK untouched.  This is a machine-dependent issue, actually.  */
@@ -4961,7 +4961,7 @@ ok_for_early_queue_removal (rtx insn)
       rtx prev_insn;
       int n_cycles;
       int i = scheduled_insns.length ();
-      for (n_cycles = flag_sched_stalled_insns_dep; n_cycles; n_cycles--)
+      for (n_cycles = GCC_OPTION (flag_sched_stalled_insns_dep); n_cycles; n_cycles--)
 	{
 	  while (i-- > 0)
 	    {
@@ -4980,7 +4980,7 @@ ok_for_early_queue_removal (rtx insn)
 		      cost = dep_cost (dep);
 
 		      if (targetm.sched.is_costly_dependence (dep, cost,
-				flag_sched_stalled_insns_dep - n_cycles))
+				GCC_OPTION (flag_sched_stalled_insns_dep) - n_cycles))
 			return false;
 		    }
 		}
@@ -5028,7 +5028,7 @@ early_queue_to_ready (state_t state, struct ready_list *ready)
          (flag_sched_stalled_insns = 0)
   */
 
-  if (! flag_sched_stalled_insns)
+  if (! GCC_OPTION (flag_sched_stalled_insns))
     return 0;
 
   for (stalls = 0; stalls <= max_insn_queue_index; stalls++)
@@ -5079,7 +5079,7 @@ early_queue_to_ready (state_t state, struct ready_list *ready)
 				 (*current_sched_info->print_insn) (insn, 0));
 
 		      insns_removed++;
-		      if (insns_removed == flag_sched_stalled_insns)
+		      if (insns_removed == GCC_OPTION (flag_sched_stalled_insns))
 			/* Remove no more than flag_sched_stalled_insns insns
 			   from Q at a time.  */
 			return insns_removed;
@@ -6546,10 +6546,10 @@ set_priorities (rtx head, rtx tail)
 void
 setup_sched_dump (void)
 {
-  sched_verbose = sched_verbose_param;
-  if (sched_verbose_param == 0 && dump_file)
+  sched_verbose = GCC_OPTION (sched_verbose_param);
+  if (GCC_OPTION (sched_verbose_param) == 0 && dump_file)
     sched_verbose = 1;
-  sched_dump = ((sched_verbose_param >= 10 || !dump_file)
+  sched_dump = ((GCC_OPTION (sched_verbose_param) >= 10 || !dump_file)
 		? stderr : dump_file);
 }
 
@@ -6610,7 +6610,7 @@ sched_init (void)
 {
   /* Disable speculative loads in their presence if cc0 defined.  */
 #ifdef HAVE_cc0
-  flag_schedule_speculative_load = 0;
+  GCC_OPTION (flag_schedule_speculative_load) = 0;
 #endif
 
   if (targetm.sched.dispatch (NULL_RTX, IS_DISPATCH_ON))
@@ -6618,7 +6618,7 @@ sched_init (void)
 
   if (live_range_shrinkage_p)
     sched_pressure = SCHED_PRESSURE_WEIGHTED;
-  else if (flag_sched_pressure
+  else if (GCC_OPTION (flag_sched_pressure)
 	   && !reload_completed
 	   && common_sched_info->sched_pass_id == SCHED_RGN_PASS)
     sched_pressure = ((enum sched_pressure_algorithm)
@@ -7648,7 +7648,7 @@ sched_create_recovery_edges (basic_block first_bb, basic_block rec,
     /* Partition type is the same, if it is "unpartitioned".  */
     {
       /* Rewritten from cfgrtl.c.  */
-      if (flag_reorder_blocks_and_partition
+      if (GCC_OPTION (flag_reorder_blocks_and_partition)
 	  && targetm_common.have_named_sections)
 	{
 	  /* We don't need the same note for the check because
diff --git a/gcc/ifcvt.c b/gcc/ifcvt.c
index 79aa2f3..f63abce 100644
--- a/gcc/ifcvt.c
+++ b/gcc/ifcvt.c
@@ -4233,7 +4233,7 @@ dead_or_predicable (basic_block test_bb, basic_block merge_bb,
 	 register used to pass function parameters, which then must be
 	 saved in caller-saved regs.  A caller-saved reg requires the
 	 prologue, killing a shrink-wrap opportunity.  */
-      if ((flag_shrink_wrap && HAVE_simple_return && !epilogue_completed)
+      if ((GCC_OPTION (flag_shrink_wrap) && HAVE_simple_return && !epilogue_completed)
 	  && ENTRY_BLOCK_PTR_FOR_FN (cfun)->next_bb == test_bb
 	  && single_succ_p (new_dest)
 	  && single_succ (new_dest) == EXIT_BLOCK_PTR_FOR_FN (cfun)
@@ -4405,7 +4405,7 @@ if_convert (bool after_combine)
   basic_block bb;
   int pass;
 
-  if (optimize == 1)
+  if (GCC_OPTION (optimize) == 1)
     {
       df_live_add_problem ();
       df_live_set_all_dirty ();
@@ -4489,7 +4489,7 @@ if_convert (bool after_combine)
 	       num_true_changes);
     }
 
-  if (optimize == 1)
+  if (GCC_OPTION (optimize) == 1)
     df_remove_problem (df_live);
 
 #ifdef ENABLE_CHECKING
@@ -4500,7 +4500,7 @@ if_convert (bool after_combine)
 static bool
 gate_handle_if_conversion (void)
 {
-  return (optimize > 0)
+  return (GCC_OPTION (optimize) > 0)
     && dbg_cnt (if_conversion);
 }
 
@@ -4508,7 +4508,7 @@ gate_handle_if_conversion (void)
 static unsigned int
 rest_of_handle_if_conversion (void)
 {
-  if (flag_if_conversion)
+  if (GCC_OPTION (flag_if_conversion))
     {
       if (dump_file)
 	{
@@ -4564,7 +4564,7 @@ make_pass_rtl_ifcvt (gcc::context *ctxt)
 static bool
 gate_handle_if_after_combine (void)
 {
-  return optimize > 0 && flag_if_conversion
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_if_conversion)
     && dbg_cnt (if_after_combine);
 }
 
@@ -4620,7 +4620,7 @@ make_pass_if_after_combine (gcc::context *ctxt)
 static bool
 gate_handle_if_after_reload (void)
 {
-  return optimize > 0 && flag_if_conversion2
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_if_conversion2)
     && dbg_cnt (if_after_reload);
 }
 
diff --git a/gcc/incpath.c b/gcc/incpath.c
index f495c0a..cb88fce 100644
--- a/gcc/incpath.c
+++ b/gcc/incpath.c
@@ -153,13 +153,13 @@ add_standard_paths (const char *sysroot, const char *iprefix,
 				    imultilib, NULL);
 		  else if (p->multilib == 2)
 		    {
-		      if (!imultiarch)
+		      if (!GCC_OPTION (imultiarch))
 			{
 			  free (str);
 			  continue;
 			}
 		      str = reconcat (str, str, dir_separator_str,
-				      imultiarch, NULL);
+				      GCC_OPTION (imultiarch), NULL);
 		    }
 		  add_path (str, SYSTEM, p->cxx_aware, false);
 		}
@@ -219,12 +219,12 @@ add_standard_paths (const char *sysroot, const char *iprefix,
 	    str = reconcat (str, str, dir_separator_str, imultilib, NULL);
 	  else if (p->multilib == 2)
 	    {
-	      if (!imultiarch)
+	      if (!GCC_OPTION (imultiarch))
 		{
 		  free (str);
 		  continue;
 		}
-	      str = reconcat (str, str, dir_separator_str, imultiarch, NULL);
+	      str = reconcat (str, str, dir_separator_str, GCC_OPTION (imultiarch), NULL);
 	    }
 
 	  add_path (str, SYSTEM, p->cxx_aware, false);
diff --git a/gcc/init-regs.c b/gcc/init-regs.c
index fcc6e2c..b4af057 100644
--- a/gcc/init-regs.c
+++ b/gcc/init-regs.c
@@ -51,7 +51,7 @@ initialize_uninitialized_regs (void)
   basic_block bb;
   bitmap already_genned = BITMAP_ALLOC (NULL);
 
-  if (optimize == 1)
+  if (GCC_OPTION (optimize) == 1)
     {
       df_live_add_problem ();
       df_live_set_all_dirty ();
@@ -115,7 +115,7 @@ initialize_uninitialized_regs (void)
 	}
     }
 
-  if (optimize == 1)
+  if (GCC_OPTION (optimize) == 1)
     {
       if (dump_file)
 	df_dump (dump_file);
@@ -128,7 +128,7 @@ initialize_uninitialized_regs (void)
 static bool
 gate_initialize_regs (void)
 {
-  return optimize > 0;
+  return GCC_OPTION (optimize) > 0;
 }
 
 static unsigned int
diff --git a/gcc/internal-fn.c b/gcc/internal-fn.c
index 9926ec2..cf9b8f1 100644
--- a/gcc/internal-fn.c
+++ b/gcc/internal-fn.c
@@ -870,7 +870,7 @@ static void
 expand_BUILTIN_EXPECT (gimple stmt)
 {
   /* When guessing was done, the hints should be already stripped away.  */
-  gcc_assert (!flag_guess_branch_prob || optimize == 0 || seen_error ());
+  gcc_assert (!GCC_OPTION (flag_guess_branch_prob) || GCC_OPTION (optimize) == 0 || seen_error ());
 
   rtx target;
   tree lhs = gimple_call_lhs (stmt);
diff --git a/gcc/ipa-cp.c b/gcc/ipa-cp.c
index b71048a..84f042a 100644
--- a/gcc/ipa-cp.c
+++ b/gcc/ipa-cp.c
@@ -514,7 +514,7 @@ ipcp_cloning_candidate_p (struct cgraph_node *node)
 
   gcc_checking_assert (cgraph_function_with_gimple_body_p (node));
 
-  if (!flag_ipa_cp_clone)
+  if (!GCC_OPTION (flag_ipa_cp_clone))
     {
       if (dump_file)
         fprintf (dump_file, "Not considering %s for cloning; "
@@ -838,7 +838,7 @@ ipa_value_from_jfunc (struct ipa_node_params *info, struct ipa_jump_func *jfunc)
 
 	  if (!info->lattices)
 	    {
-	      gcc_checking_assert (!flag_ipa_cp);
+	      gcc_checking_assert (!GCC_OPTION (flag_ipa_cp));
 	      return NULL_TREE;
 	    }
 	  lat = ipa_get_scalar_lat (info, idx);
@@ -1534,7 +1534,7 @@ ipa_get_indirect_edge_target_1 (struct cgraph_edge *ie,
 	return NULL_TREE;
     }
 
-  if (!flag_devirtualize)
+  if (!GCC_OPTION (flag_devirtualize))
     return NULL_TREE;
 
   gcc_assert (!ie->indirect_info->agg_contents);
@@ -1731,7 +1731,7 @@ good_cloning_opportunity_p (struct cgraph_node *node, int time_benefit,
 			    int freq_sum, gcov_type count_sum, int size_cost)
 {
   if (time_benefit == 0
-      || !flag_ipa_cp_clone
+      || !GCC_OPTION (flag_ipa_cp_clone)
       || !optimize_function_for_speed_p (DECL_STRUCT_FUNCTION (node->decl)))
     return false;
 
@@ -2296,7 +2296,7 @@ ipcp_propagate_stage (struct topo_info *topo)
   if (dump_file)
     fprintf (dump_file, "\n Propagating constants:\n\n");
 
-  if (in_lto_p)
+  if (GCC_OPTION (in_lto_p))
     ipa_update_after_lto_read ();
 
 
@@ -3763,7 +3763,7 @@ cgraph_gate_cp (void)
 {
   /* FIXME: We should remove the optimize check after we ensure we never run
      IPA passes when not optimizing.  */
-  return flag_ipa_cp && optimize;
+  return GCC_OPTION (flag_ipa_cp) && GCC_OPTION (optimize);
 }
 
 namespace {
diff --git a/gcc/ipa-devirt.c b/gcc/ipa-devirt.c
index 2f84f17..fb29d48 100644
--- a/gcc/ipa-devirt.c
+++ b/gcc/ipa-devirt.c
@@ -200,7 +200,7 @@ hash_type_name (tree t)
 
   /* If not in LTO, all main variants are unique, so we can do
      pointer hash.  */
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     return htab_hash_pointer (t);
 
   /* Anonymous types are unique.  */
@@ -247,7 +247,7 @@ odr_hasher::equal (const value_type *t1, const compare_type *ct2)
   gcc_checking_assert (TYPE_MAIN_VARIANT (ct2) == ct2);
   if (t1->type == t2)
     return true;
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     return false;
   return types_same_for_odr (t1->type, t2);
 }
@@ -292,7 +292,7 @@ add_type_duplicate (odr_type val, tree type)
     {
       bool merge = true;
       bool base_mismatch = false;
-      gcc_assert (in_lto_p);
+      gcc_assert (GCC_OPTION (in_lto_p));
       vec_safe_push (val->types, type);
       unsigned int i,j;
 
@@ -367,7 +367,7 @@ add_type_duplicate (odr_type val, tree type)
 	 merged LTO unit.  For this reason we absolutely need to remove
 	 them and replace by internal variants. Not doing so will lead
          to incomplete answers from possible_polymorphic_call_targets.  */
-      if (!flag_ltrans && merge)
+      if (!GCC_OPTION (flag_ltrans) && merge)
 	{
 	  tree master_binfo = TYPE_BINFO (val->type);
 	  tree v1 = BINFO_VTABLE (master_binfo);
@@ -617,7 +617,7 @@ maybe_record_node (vec <cgraph_node *> &nodes,
     {
       /* The only case when method of anonymous namespace becomes unreferable
 	 is when we completely optimized it out.  */
-      if (flag_ltrans
+      if (GCC_OPTION (flag_ltrans)
 	  || !target 
           || !type_in_anonymous_namespace_p (DECL_CONTEXT (target)))
 	*completep = false;
@@ -721,7 +721,7 @@ record_target_from_binfo (vec <cgraph_node *> &nodes,
 	}
       /* For types in anonymous namespace first check if the respective vtable
 	 is alive. If not, we know the type can't be called.  */
-      if (!flag_ltrans && anonymous)
+      if (!GCC_OPTION (flag_ltrans) && anonymous)
 	{
 	  tree vtable = BINFO_VTABLE (inner_binfo);
 	  varpool_node *vnode;
@@ -1530,7 +1530,7 @@ possible_polymorphic_call_targets (tree otr_type,
     {
       /* For anonymous namespace types we can attempt to build full type.
 	 All derivations must be in this unit (unless we see partial unit).  */
-      if (!type->anonymous_namespace || flag_ltrans)
+      if (!type->anonymous_namespace || GCC_OPTION (flag_ltrans))
 	complete = false;
       for (i = 0; i < outer_type->derived_types.length(); i++)
 	possible_polymorphic_call_targets_1 (nodes, inserted,
@@ -1603,10 +1603,10 @@ dump_possible_polymorphic_call_targets (FILE *f,
 	fprintf (f, "\n     If the type is in construction,"
 		 " then additional tarets are:\n"
 		 "      ");
-      if (in_lto_p)
+      if (GCC_OPTION (in_lto_p))
 	name = cplus_demangle_v3 (targets[i]->asm_name (), 0);
       fprintf (f, " %s/%i", name ? name : targets[i]->name (), targets[i]->order);
-      if (in_lto_p)
+      if (GCC_OPTION (in_lto_p))
 	free (name);
       if (!targets[i]->definition)
 	fprintf (f, " (no definition%s)",
@@ -1885,9 +1885,9 @@ ipa_devirt (void)
 static bool
 gate_ipa_devirt (void)
 {
-  return (flag_devirtualize
-	  && flag_devirtualize_speculatively
-	  && optimize);
+  return (GCC_OPTION (flag_devirtualize)
+	  && GCC_OPTION (flag_devirtualize_speculatively)
+	  && GCC_OPTION (optimize));
 }
 
 namespace {
diff --git a/gcc/ipa-inline-analysis.c b/gcc/ipa-inline-analysis.c
index 98f42ef..9cf6866 100644
--- a/gcc/ipa-inline-analysis.c
+++ b/gcc/ipa-inline-analysis.c
@@ -1568,7 +1568,7 @@ eliminated_by_inlining_prob (gimple stmt)
   enum gimple_code code = gimple_code (stmt);
   enum tree_code rhs_code;
 
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return 0;
 
   switch (code)
@@ -2433,7 +2433,7 @@ estimate_function_body_sizes (struct cgraph_node *node, bool early)
   info->conds = NULL;
   info->entry = NULL;
 
-  if (optimize && !early)
+  if (GCC_OPTION (optimize) && !early)
     {
       calculate_dominance_info (CDI_DOMINATORS);
       loop_optimizer_init (LOOPS_NORMAL | LOOPS_HAVE_RECORDED_EXITS);
@@ -2774,7 +2774,7 @@ estimate_function_body_sizes (struct cgraph_node *node, bool early)
   inline_summary (node)->self_time = time;
   inline_summary (node)->self_size = size;
   nonconstant_names.release ();
-  if (optimize && !early)
+  if (GCC_OPTION (optimize) && !early)
     {
       loop_optimizer_finalize ();
       free_dominance_info (CDI_DOMINATORS);
@@ -2825,13 +2825,13 @@ compute_inline_parameters (struct cgraph_node *node, bool early)
   push_cfun (DECL_STRUCT_FUNCTION (node->decl));
 
   /* Estimate the stack size for the function if we're optimizing.  */
-  self_stack_size = optimize ? estimated_stack_frame_size (node) : 0;
+  self_stack_size = GCC_OPTION (optimize) ? estimated_stack_frame_size (node) : 0;
   info->estimated_self_stack_size = self_stack_size;
   info->estimated_stack_size = self_stack_size;
   info->stack_frame_offset = 0;
 
   /* Can this function be inlined at all?  */
-  if (!optimize && !lookup_attribute ("always_inline",
+  if (!GCC_OPTION (optimize) && !lookup_attribute ("always_inline",
 				      DECL_ATTRIBUTES (node->decl)))
     info->inlinable = false;
   else
@@ -2948,7 +2948,7 @@ estimate_edge_devirt_benefit (struct cgraph_edge *ie,
 
   if (!known_vals.exists () && !known_binfos.exists ())
     return false;
-  if (!flag_indirect_inlining)
+  if (!GCC_OPTION (flag_indirect_inlining))
     return false;
 
   target = ipa_get_indirect_edge_target (ie, known_vals, known_binfos,
@@ -3851,10 +3851,10 @@ inline_analyze_function (struct cgraph_node *node)
   if (dump_file)
     fprintf (dump_file, "\nAnalyzing function: %s/%u\n",
 	     node->name (), node->order);
-  if (optimize && !node->thunk.thunk_p)
+  if (GCC_OPTION (optimize) && !node->thunk.thunk_p)
     inline_indirect_intraprocedural_analysis (node);
   compute_inline_parameters (node, false);
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     {
       struct cgraph_edge *e;
       for (e = node->callees; e; e = e->next_callee)
@@ -3893,7 +3893,7 @@ inline_generate_summary (void)
 
   /* When not optimizing, do not bother to analyze.  Inlining is still done
      because edge redirection needs to happen there.  */
-  if (!optimize && !flag_lto && !flag_wpa)
+  if (!GCC_OPTION (optimize) && !GCC_OPTION (flag_lto) && !GCC_OPTION (flag_wpa))
     return;
 
   function_insertion_hook_holder =
@@ -4075,10 +4075,10 @@ inline_read_summary (void)
 	   unit, so this should never happen.  */
 	fatal_error ("ipa inline summary is missing in input file");
     }
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       ipa_register_cgraph_hooks ();
-      if (!flag_ipa_cp)
+      if (!GCC_OPTION (flag_ipa_cp))
 	ipa_prop_read_jump_functions ();
     }
   function_insertion_hook_holder =
@@ -4198,7 +4198,7 @@ inline_write_summary (void)
   produce_asm (ob, NULL);
   destroy_output_block (ob);
 
-  if (optimize && !flag_ipa_cp)
+  if (GCC_OPTION (optimize) && !GCC_OPTION (flag_ipa_cp))
     ipa_prop_write_jump_functions ();
 }
 
diff --git a/gcc/ipa-inline-transform.c b/gcc/ipa-inline-transform.c
index b2e0285..a5ba5fe 100644
--- a/gcc/ipa-inline-transform.c
+++ b/gcc/ipa-inline-transform.c
@@ -273,7 +273,7 @@ inline_call (struct cgraph_edge *e, bool update_original,
 
   old_size = inline_summary (to)->size;
   inline_merge_summary (e);
-  if (optimize)
+  if (GCC_OPTION (optimize))
     new_edges_found = ipa_propagate_indirect_call_infos (curr, new_edges);
   if (update_overall_summary)
    inline_update_overall_summary (to);
@@ -449,7 +449,7 @@ inline_transform (struct cgraph_node *node)
   ipa_remove_all_references (&node->ref_list);
 
   timevar_push (TV_INTEGRATION);
-  if (node->callees && optimize)
+  if (node->callees && GCC_OPTION (optimize))
     todo = optimize_inline_calls (current_function_decl);
   timevar_pop (TV_INTEGRATION);
 
